﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.31
@EndOfDesignText@
Sub Class_Globals
	Private xui As XUI
	Private pnlGrid As B4XView
	Private cvs As B4XCanvas
	Private fx As JFX
	
	Type grid(gridStep As Double, sizeX As Int, sizeY As Int, width As Double, height As Double, _
 	left As Double, right As Double, top As Double, btm As Double, matrix(,) As Int)
        
	Type Point(x As Double, y As Double)
	
	Private cvsCenterX As Double
	Private cvsCenterY As Double
     
	Private testGrid As grid
	
	Private gridX = 30 As Int
	Private gridy = 30 As Int
	Private gridBlock = 10 As Int
	
	Private colorMap As Map

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout("GridPanel")
	colorMap.Initialize
	colorMap.Put(1, fx.Colors.Red)
	colorMap.Put(2, fx.Colors.Green)
	colorMap.Put(3, fx.Colors.Blue)
	cvs.Initialize(pnlGrid)
	cvsCenterX = pnlGrid.Width / 2
	cvsCenterY = pnlGrid.Height / 2
	InitCode
	DrawAll	
	cvs.Invalidate
End Sub

#Region User Code
Sub InitCode
	InitializeGrid(gridy, gridX, gridBlock)
End Sub
#End Region

#Region Utilities	

	'Returns the cell corresponding to the given pixel location
Sub PixelToGrid(x As Double, y As Double) As Point
	Dim p As Point : p.initialize
	p.x = Max(Min((-testGrid.left + x) / testGrid.gridStep, testGrid.sizeX - 1), 0)
	p.y = Max(Min((-testGrid.top  + y) / testGrid.gridStep, testGrid.sizeY - 1), 0)
	Log("Pixel to Grid= " & Floor(p.x) &" "& Floor(p.y)) '*****************************************
	Return p
End Sub

#End Region

#Region User Interface

Sub pnlGrid_MouseDragged (EventData As MouseEvent)
	Dim p = PixelToGrid(EventData.X, EventData.Y) As Point
	If EventData.PrimaryButtonDown Then testGrid.matrix(p.x, p.y) = 3 Else testGrid.matrix(p.x, p.y) = 0
End Sub

Sub pnlGrid_MousePressed (EventData As MouseEvent)
	Dim p = PixelToGrid(EventData.X, EventData.Y) As Point
	If EventData.PrimaryButtonDown Then testGrid.matrix(p.x, p.y) = 2 Else testGrid.matrix(p.x, p.y) = 0
End Sub

#End Region


#Region PreBaked Code
Sub InitializeGrid(sizeX As Int, sizeY As Int, gridStep As Double)
	If gridStep <= 0 Then gridStep = 10
	If sizeX <= 0 Or sizeY <= 0 Then
'		sizeX = cvs.Width  / gridStep
'		sizeY = cvs.Height / gridStep
		sizeX = pnlGrid.Width  / gridStep
		sizeY = pnlGrid.Height / gridStep
	End If
	testGrid.Initialize
	testGrid.gridStep = gridStep
	testGrid.sizeX    = sizeX
	testGrid.sizeY    = sizeY
	testGrid.width    = sizeX * gridStep
	testGrid.height   = sizeY * gridStep
	testGrid.left     = cvsCenterX - (testGrid.width / 2)
	testGrid.top      = cvsCenterY - (testGrid.height / 2)
	testGrid.right    = testGrid.left + testGrid.width
	testGrid.btm      = testGrid.top  + testGrid.height
	Dim matrix(sizeX, sizeY) As Int : testGrid.matrix = matrix
End Sub

Sub DrawAll
	ClearCanvas
	DrawGrid
	DrawCells
End Sub


Sub ClearCanvas
	cvs.ClearRect(cvs.TargetRect)
End Sub

Sub DrawCells
	Dim R As B4XRect
	Dim gX, gY As Double
	For x = 0 To testGrid.sizeX - 1
		gX = testGrid.left + (x * testGrid.gridStep)
		For y = 0 To testGrid.sizeY - 1
			gY = testGrid.top + (y * testGrid.gridStep)
			If testGrid.matrix(x, y) > 0 Then
'				cvs.DrawRect(gX, gY, testGrid.gridStep, testGrid.gridStep, colorMap.Get(testGrid.matrix(x, y)), 5)
				R.Initialize(gX,gY,testGrid.gridStep, testGrid.gridStep)
				cvs.DrawRect(R, colorMap.Get(testGrid.matrix(x, y)), True, 5)
			End If
		Next
	Next
End Sub


Sub DrawGrid
	For x = testGrid.left To (testGrid.left + testGrid.width) Step testGrid.gridStep
		cvs.DrawLine(x, testGrid.top, x, testGrid.btm, xui.Color_DarkGray, 1)
	Next
	For y = testGrid.top To (testGrid.top + testGrid.height) Step testGrid.gridStep
		cvs.DrawLine(testGrid.left, y, testGrid.right, y, xui.Color_DarkGray, 1)
	Next
End Sub
#End Region


Sub pnlGrid_Resize (Width As Double, Height As Double)
	
End Sub



Sub btnClear_MouseClicked (EventData As MouseEvent)
	ClearCanvas
End Sub

Sub btnHome_MouseClicked (EventData As MouseEvent)
	DrawGrid
End Sub

Sub btnLeft_MouseClicked (EventData As MouseEvent)
	testGrid.matrix(5, 5) = 2
End Sub