﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.31
@EndOfDesignText@
Sub Class_Globals
	Type grid(gridStep As Double, sizeX As Int, sizeY As Int, width As Double, height As Double, _
 	left As Double, right As Double, top As Double, btm As Double, matrix(,) As Int)
        
	Type Point(x As Double, y As Double)

	Private fx As JFX
	Private xui As XUI
	Private pnlGrid As B4XView
	
	Private cvs As B4XCanvas
	Private cvsCenterX As Double
	Private cvsCenterY As Double
     
	Private testGrid As grid
	Private MainLoop As Timer
	Private colorMap As Map
	
	Private gridX = 20 As Int
	Private gridy = 20 As Int
	Private gridBlock = 10 As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout("GridPanel")

'	cvs.Initialize("cvs")
'	MainForm.RootPane.AddNode(cvs, 0, 0, MainForm.Width, MainForm.Height)
'	cvsCenterX = cvs.Width / 2
'	cvsCenterY = cvs.Height / 2

	cvs.Initialize(pnlGrid)
	cvsCenterX = cvs.TargetRect.Width / 2
	Log(cvsCenterX)
	cvsCenterY = cvs.TargetRect.Height / 2
	Log(cvsCenterY)
	
	colorMap.Initialize
	colorMap.Put(1, xui.Color_Red)
	colorMap.Put(2, xui.Color_Blue)
	colorMap.Put(3, xui.Color_Green)
	colorMap.Put(4, xui.Color_Black)

	InitCode
	
	MainLoop.Initialize("MainLoop", 100)
	MainLoop.Enabled = True

End Sub

#Region User Code
Sub InitCode
	InitializeGrid(0, 0, gridBlock)
End Sub

Sub MainLoop_Tick
	DrawAll
'	Dim R As B4XRect
''	R.Initialize(pnlGrid.Left,pnlGrid.Width,pnlGrid.Top,pnlGrid.Height)
'	R.Initialize(pnlGrid.Left,pnlGrid.Top,pnlGrid.Width-10,pnlGrid.Height-5)
'	cvs.DrawRect(R, xui.Color_Blue, False, 10)
	Log(pnlGrid.Left)
	Log(pnlGrid.Top)
	Log(pnlGrid.Width)
	Log(pnlGrid.Height)
	
End Sub
#End Region

Sub DrawAll
	ClearCanvas
	DrawCells
	DrawGrid
End Sub

#Region PreBaked Code
Sub InitializeGrid(sizeX As Int, sizeY As Int, gridStep As Double)
	If gridStep <= 0 Then gridStep = 10
	If sizeX <= 0 Or sizeY <= 0 Then
'		sizeX = cvs.Width  / gridStep  '*********************
'		sizeY = cvs.Height / gridStep  '*********************
'		sizeX = pnlGrid.Width  / gridStep ' works
'		sizeY = pnlGrid.Height / gridStep ' works
		sizeX = cvs.TargetRect.Width / gridStep
		Log($"sizeX= ${sizeX}"$)
		sizeY = cvs.TargetRect.Height / gridStep
		Log($"sizeY= ${sizeY}"$)
	End If
	testGrid.Initialize
	testGrid.gridStep = gridStep
	testGrid.sizeX    = sizeX
	testGrid.sizeY    = sizeY
	testGrid.width    = sizeX * gridStep
	testGrid.height   = sizeY * gridStep
	testGrid.left     = cvsCenterX - (testGrid.width / 2)
	testGrid.top      = cvsCenterY - (testGrid.height / 2)
	testGrid.right    = testGrid.left + testGrid.width
	testGrid.btm      = testGrid.top  + testGrid.height
	Dim matrix(sizeX, sizeY) As Int : testGrid.matrix = matrix
End Sub

'Sub RandomlyPopulateGrid(densityPercentage As Int)
'	Dim lowest = 1, highest As Int
'	For Each key In colorMap.Keys : highest = Max(highest, key) : Next
'		For x = 0 To testGrid.sizeX - 1
'			For y = 0 To testGrid.sizeY - 1
'				If Rnd(0, 101) > densityPercentage Then Continue
'				testGrid.matrix(x, y) = Rnd(lowest, highest + 1)
'			Next
'		Next
'	End Sub


Sub ClearCanvas
	cvs.ClearRect(cvs.TargetRect)
	cvs.Release '******************************************************
End Sub

Sub DrawCells
'	Log("Test")
	Dim gX, gY As Double
	For x = 0 To testGrid.sizeX - 1
		gX = testGrid.left + (x * testGrid.gridStep)
		For y = 0 To testGrid.sizeY - 1
			gY = testGrid.top + (y * testGrid.gridStep)
			If testGrid.matrix(x, y) > 0 Then
'				cvs.DrawRect(gX, gY, testGrid.gridStep, testGrid.gridStep, _
'				 colorMap.Get(testGrid.matrix(x, y)), True, 0)
				Dim R As B4XRect
				R.Initialize(gX,gY,testGrid.gridStep, testGrid.gridStep)      ' ***************
				cvs.DrawRect(R, colorMap.Get(testGrid.matrix(x, y)), True, 0) ' ***************
'				cvs.DrawRect(R, xui.Color_Blue, True, 0) ' ***************
			End If
		Next
	Next
End Sub

Sub DrawGrid
	For x = testGrid.left To (testGrid.left + testGrid.width) Step testGrid.gridStep
		cvs.DrawLine(x, testGrid.top, x, testGrid.btm, xui.Color_DarkGray, 1) ' **** xui color
	Next
	For y = testGrid.top To (testGrid.top + testGrid.height) Step testGrid.gridStep
		cvs.DrawLine(testGrid.left, y, testGrid.right, y, xui.Color_DarkGray, 1) ' *** xui color
	Next
	cvs.Release ' ******************************************************************
End Sub
#End Region

Sub pnlGrid_Resize (Width As Double, Height As Double)
	
End Sub


#Region Utilities	
	'Returns the cell corresponding to the given pixel location
Sub PixelToGrid(x As Double, y As Double) As Point
	Dim p As Point : p.initialize
	p.x = Max(Min((-testGrid.left + x) / testGrid.gridStep, testGrid.sizeX - 1), 0)
	p.y = Max(Min((-testGrid.top  + y) / testGrid.gridStep, testGrid.sizeY - 1), 0)
	Log("Pixel to Grid= " & Floor(p.x) &" "& Floor(p.y)) '*****************************************
	Return p
End Sub
#End Region

#Region User Interface
Sub pnlGrid_MouseDragged (EventData As MouseEvent)
	Dim p = PixelToGrid(EventData.X, EventData.Y) As Point
	If EventData.PrimaryButtonDown Then testGrid.matrix(p.x, p.y) = 3 Else testGrid.matrix(p.x, p.y) = 0
End Sub

Sub pnlGrid_MousePressed (EventData As MouseEvent)
	Dim p = PixelToGrid(EventData.X, EventData.Y) As Point
	If EventData.PrimaryButtonDown Then testGrid.matrix(p.x, p.y) = 2 Else testGrid.matrix(p.x, p.y) = 0
End Sub
#End Region


